-- What the NEB module will use to insert a new hostgroup and its members

CREATE or REPLACE FUNCTION new_hostgroup(text,text) RETURNS 
integer AS
'       DECLARE
		thisGroupName	alias for $1;
		thisGroupAlias	alias for $2;
     		thisGroupID	int;
        BEGIN
		-- Get the group id. If this is a new group (and it better be) 
		-- then insert the group and get the id. Otherwise return an invalid group id.
		select into thisGroupID id FROM hostgroup WHERE name = thisGroupName;

		if thisGroupID is null then
			insert into hostgroup (name,alias) values (thisGroupName,thisGroupAlias);

			-- assume for the moment that this worked just fine
			thisGroupID := currval(''public.hostgroup_id_seq'');
		else
			-- we will treat 0 as a magic, invalid number
			thisGroupID := 0;
		end if;

		return thisGroupID;
        END;
' LANGUAGE 'plpgsql';

CREATE or REPLACE FUNCTION append_to_hostgroup(int,text) RETURNS 
integer AS
'       DECLARE
		thisGroupID	alias for $1;
		thisHostName	alias for $2;
		thisHostID	int;
        BEGIN
		-- Get the host id. 
		select into thisHostID id FROM host WHERE name = thisHostName;

		insert into hostgroup_membership (hostid,groupid) values (thisHostID,thisGroupID);

		-- check the magic variable FOUND.... it should be set to true, as we should have just inserted a row.
		if FOUND then
			return 0;
		else
			return -1;
		end if;

		-- should never get here
		return -2;
        END;
' LANGUAGE 'plpgsql';

