<?php
	// set up the variables
	$conn = pg_pconnect("host=dumont user=postgres dbname=nag");

	if(!$conn)
	{
		echo pg_errormessage($conn);
		exit;
	}

	function query($sql)
	{
		global $conn;
		return pg_query($conn,$sql);
	}

	function prettyTime($time)
	{

		$days = floor($time/60/60/24);
		$time -= $days*60*60*24;
		$hours = floor($time/60/60);
		$time -= $hours*60*60;
		$minutes = floor($time/60);
		$time -= $minutes*60;
		$seconds = $time;

		return ($days . "d " . $hours . "h " . $minutes . "m " . $seconds . "s");
	}

	$rowColor1 = "#CCFFCC";
	$rowColor2 = "#CCCCFF";
	
?>           

<html>
<head>
	<title>service details</title>
</head>

<body>

<table width="100%">
<tr>
	<td colspan=7><b>Service Status Details</b></td>
</tr>
<tr bgcolor="tan">
	<td>Host</td>
	<td>Service</td>
	<td>Last Check</td>
	<td>Next Check</td>
	<td>Duration</td>
	<td>Attempt</td>
	<td>Status Info</td>
</tr>
<?php
	// start off with the unconstrained query
	$string = "select hostid,name,hostgroup,host_soft_state,host_notifications,service,service_soft_state,service_notifications,last_check,next_check,duration,current_attempt,max_attempts,plugin_output from host_details";
	$constrained = 0;

	// check for a hostgroup constraint
	$hostgroupCount = 0;
	if(isset($_GET["hostgroups"])) 
	{
		$hostgroups = $_GET["hostgroups"];
		$hostgroupCount = count($hostgroups);
	}
	if($hostgroupCount > 0)
	{
		if($constrained > 0)
		{
			$string = $string . " and ";
		}
		else
		{
			$string = $string . " where ";
		}
		$constrained++;

		$string = $string . "hostgroup in (";

		$i = 0;
		foreach($hostgroups as $value)
		{
			// yay for sql insertion attacks!
			$string = $string . $value;
			if($i < $hostgroupCount - 1)
			{
				$string = $string . ",";
			}
			$i++;
		}
		$string = $string . ")";
	}

	// check for a service description contraint
	$servicesCount = 0;
	if(isset($_GET["services"]))
	{
		$services = $_GET["services"];
		$servicesCount = count($services);
	}
	if($servicesCount > 0)
	{
		if($constrained > 0)
		{
			$string = $string . " and ";
		}
		else
		{
			$string = $string . " where ";
		}
		$constrained++;

		$string = $string . "service in (";

		$i = 0;
		foreach($services as $value)
		{
			// yay for sql insertion attacks!
			$string = $string . "'" . $value . "'";
			if($i < $servicesCount - 1)
			{
				$string = $string . ",";
			}
			$i++;
		}
		$string = $string . ")";
	}

	// check for a service state contraint
	$servicestateCount = 0;
	if(isset($_GET["servicestates"]))
	{
		$servicestates = $_GET["servicestates"];
		$servicestateCount = count($servicestates);
	}
	if($servicestateCount > 0)
	{
		if($constrained > 0)
		{
			$string = $string . " and ";
		}
		else
		{
			$string = $string . " where ";
		}
		$constrained++;

		$string = $string . "service_soft_state in (";

		$i = 0;
		foreach($servicestates as $value)
		{
			// yay for sql insertion attacks!
			$string = $string . $value;
			if($i < $servicestateCount - 1)
			{
				$string = $string . ",";
			}
			$i++;
		}
		$string = $string . ")";
	}

	// check for a host state contraint
	$hoststateCount = 0;
	if(isset($_GET["hoststates"]))
	{
		$hoststates = $_GET["hoststates"];
		$hoststateCount = count($hoststates);
	}
	if($hoststateCount > 0)
	{
		if($constrained > 0)
		{
			$string = $string . " and ";
		}
		else
		{
			$string = $string . " where ";
		}
		$constrained++;

		$string = $string . "host_soft_state in (";

		$i = 0;
		foreach($hoststates as $value)
		{
			// yay for sql insertion attacks!
			$string = $string . $value;
			if($i < $hoststateCount - 1)
			{
				$string = $string . ",";
			}
			$i++;
		}
		$string = $string . ")";
	}

	$q = query($string);
	$row_count = pg_numrows($q);

	$last_host = 0;
	$rowColor = $rowColor1;

	for($i = 0; $i < $row_count; $i++)
	{
		echo "<tr>\n";
		echo "\t<td>\n";
		if($last_host != pg_result($q,$i,0))
		{
			$last_host = pg_result($q,$i,0);
			echo "\t\t<table width=\"100%\"";
			switch(pg_result($q,$i,3))
			{
				case "0":
					echo " bgcolor=\"#33CC00\">\n";
					break;
				case "1":
					echo " bgcolor=\"#FF3300\">\n";
					break;
				case "-1":
					echo " bgcolor=\"#9900FF\">\n";
					break;
			}
			echo "\t\t<tr>\n\t\t\t<td>" . pg_result($q,$i,1) . "</td>\n";
			
			if(pg_result($q,$i,4) == "f")
			{
				echo "\t\t\t<td align=\"right\"><IMG SRC='ndisabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Notifications for this host have been disabled' TITLE='Notifications for this host have been disabled'></td>\n";
			}

			echo "\t\t</tr>\n\t\t</table>\n";
		}
		echo "\t</td>\n\t<td>\n";

		echo "\t\t<table width=\"100%\"";
		switch(pg_result($q,$i,6))
		{
			case "-1":
				echo " bgcolor=\"#9900FF\"";
				break;
			case "0":
				echo " bgcolor=\"#33CC00\"";
				break;
			case "1":
				echo " bgcolor=\"#FFFF00\"";
				break;
			case "2":
				echo " bgcolor=\"#FF3300\"";
				break;
			case "3":
				echo " bgcolor=\"#FF9900\"";
				break;
		}
		echo ">\n\t\t<tr>\n\t\t\t<td>" . pg_result($q,$i,5) . "</td>\n";
			
		if(pg_result($q,$i,7) == "f")
		{
			echo "\t\t\t<td align=\"right\"><IMG SRC='ndisabled.gif' BORDER=0 WIDTH=20 HEIGHT=20 ALT='Notifications for this service have been disabled' TITLE='Notifications for this service have been disabled'></td>\n";
		}
		echo "\t\t</tr>\n\t\t</table>\n\t</td>\n\t<td bgcolor=\"" . $rowColor . "\">";

		echo date("Y-m-d H-i-s",pg_result($q,$i,8)) . "</td>\n\t<td bgcolor=\"" . $rowColor;
		echo "\">" . date("Y-m-d H-i-s",pg_result($q,$i,9)) . "</td>\n\t<td bgcolor=\"" . $rowColor . "\">";
		echo prettyTime(pg_result($q,$i,10)) . "</td>\n\t<td bgcolor=\"" . $rowColor . "\">" . pg_result($q,$i,11);
		echo "/" . pg_result($q,$i,12) . "</td>\n\t<td bgcolor=\"" . $rowColor . "\">" . pg_result($q,$i,13);

		echo "</td>\n</tr>";

		if($rowColor == $rowColor1)
		{
			$rowColor = $rowColor2;
		}
		else
		{
			$rowColor = $rowColor1;
		}
	}
?>

</table>


</body>
</html>
